
// RS-ET62Dlg.h : wb_[ t@C
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"



#define SOCK_ARG_BLOCKING 0
#define SOCK_ARG_NON_BLOCKING 1


#define MAX_DEVICE   4	// 4܂Ō
#define IP_LENGTH   16
#define RECEIVE_BUFF_SIZE  2048
#define SEND_BUFF_SIZE     2048
#define COM_NAME_SIZE      256
#define SEND_STR_SIZE      256
#define DEV_COLUMN_COUNT   2



#define COM_WAIT_TIME   500
#define MSEC_30 30
#define MSEC_250 250
#define WAIT_PENDING_TIME  10000

// XbhpbZ[W
#define WM_RECEIVE_THREAD_MESSAGE WMID_RECEIVE_DATA
#define WM_SEND_ERR_MESSAGE WMID_SEND_ERR
#define WM_BLINK_START_MESSAGE WMID_BLINK_START
#define WM_SEARCH_START_MESSAGE WMID_SEARCH_START
#define WM_SEARCH_FINISHED_MESSAGE WMID_SEARCH_FINISHED


// EBhEbZ[WID
enum
{
	WMID_RECEIVE_DATA = WM_APP+1,
	WMID_SEND_ERR,
	WMID_SEARCH_START,
	WMID_SEARCH_FINISHED
};

// foCXI_CAO̗
enum
{
	DEV_LIST_IP,
	DEV_LIST_MAC,
};

// ^C}[ID
#define TMID_STOP_LED 1

// G[R[h
enum
{
		ERR_CMD_FAIL = -1,
	ERR_SUCCESS = 0,
		ERR_OPEN_SOCKET_FAILED,
	ERR_SOCK_NO_REC_DATA,
	ERR_SOCK_SEND_DATA_FAILED,
	ERR_SELECT_TIME_OUT,
	ERR_INVALID_EVENT,
	ERR_CONNECT_FAILED
};

// ڑ[h
enum
{
	CONNECT_SOCK,
	CONNECT_COM
};


///////////////////////////////////////////////
// RS-ET62̏
//struct DeviceInfo
//{
//	CString mac;
//	CString ip;
//};
#pragma  pack( 1 )
struct  DeviceInfo
{

	union
	{
		UINT8   IpAddress[4];	//
		ULONG   dwIpAddress;	//
	};

	UINT8   MacAddress[6];

	union
	{
		UINT8   HostIpAddress[4];	//
		ULONG   dwHostIpAddress;
	};

	UINT8   FirmVersion[ 2 ];    //t@[o[W H:L

	UINT8   typeDevice;    // ET62
#define  DEVICE_TYPE_ET60   0x01
#define  DEVICE_TYPE_ET62   0x02

	UINT8   reserved_0;    //

};
#pragma  pack()
///////////////////////////////////////////////


UINT ledCheckThread(LPVOID pDlg);
UINT deviceScanThread(LPVOID pDlg);

// CREXET62Dlg _CAO
class CREXET62Dlg : public CDialog
{
// RXgNV
public:
	CREXET62Dlg(CWnd* pParent = NULL);	// WRXgN^

// _CAO f[^
	enum { IDD = IDD_REXET62_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV T|[g


// 
protected:
	HICON m_hIcon;

	// ꂽAbZ[W蓖Ċ֐
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	volatile CWinThread* m_deviceScanThread;
	volatile CWinThread* m_ledCheckThread;

	CString m_strSend;
	CString m_strReceive;
	CString m_devPassword;
	CString m_selectedDev;

	CListCtrl m_deviceList;
	CComboBox m_comList;

	afx_msg void OnBnClickedButtonRescan();
	afx_msg void OnBnClickedButtonConnectTelnet();
	afx_msg void OnBnClickedButtonConnectCom();
	afx_msg void OnLvnItemchangedListDevice(NMHDR *pNMHDR, LRESULT *pResult);

	afx_msg LRESULT showScanDialog(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT updateDeviceList(WPARAM wParam, LPARAM lParam);

	int openSocket(CString address);
	void endSocket(SOCKET socket);
	UINT receiveSockData(void);
	int sendSockData(CString sendData);
	void searchDevice(void);
	void switchDisable(void);
	CString getSelectedDevice(UINT targetItem);
	void setDeviceList(DeviceInfo deviceInfo[], UINT deviceCount);
	void searchCom(void);
	BOOL checkSelection(void);
};
