// SocketFunc.cpp

#include "stdafx.h"
#include "RS-ET62.h"
#include "RS-ET62Dlg.h"

#include  "SocketFunc.H"

#include  "Iphlpapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//// link  "Iphlpapi.lib"
#pragma comment( lib, "Iphlpapi.lib" )

/*
  typedef struct _MIB_IPADDRTABLE 
  { 
	 DWORD dwNumEntries;  
	 MIB_IPADDRROW  table[ ANY_SIZE ];
  } MIB_IPADDRTABLE,  *PMIB_IPADDRTABLE;

  typedef struct _MIB_IPADDRROW 
  { 
	 DWORD dwAddr;      //The IPv4 address in network byte order.
	 DWORD dwIndex;  
	 DWORD dwMask;      /The subnet mask for the IPv4 address in network byte order.
	 DWORD dwBCastAddr;  
	 DWORD dwReasmSize;  
	 unsigned short unused1;  
	 unsigned short wType;
  } MIB_IPADDRROW, *PMIB_IPADDRROW;
*/
ULONG  GetNicIpAddressTable( PMIB_IPADDRTABLE *  ppIpAddrTable );

////////////////////////////////////////////////////////////////////////////////////////////////////
//
// lbg[NC^[tFCX̏擾(Ή)
//
//  p[^[
//  @PMIB_IPADDRTABLE *   ppIpAddrTable;   //擾C^[tFCX񂪊i[ꂽz̐擪AhXԂi{֐Ŕzmۂj
//  ߂l
//    ULONG   count;   //擾lbg[NC^[tFCX
//
//@iӁjĂяóAMIB_IPADDRTABLE[] 񂪕svɂȂ΁AppIpAddrTable free() ŉ邱ƁB
//
ULONG  GetNicIpAddressTable( PMIB_IPADDRTABLE *  ppIpAddrTable )
{
	DWORD  index = 0;
	PMIB_IPADDRTABLE  pIpAddrTable = NULL;
	DWORD  dwSize = 0;
	DWORD  result = 0;
	ULONG  count = 0;

	if ( GetIpAddrTable( NULL, &dwSize, 0 ) == ERROR_INSUFFICIENT_BUFFER )
	{
		pIpAddrTable = (PMIB_IPADDRTABLE) malloc( dwSize );
		TRACE( _T( " malloc()  pIpAddrTable : 0x%p\n"), pIpAddrTable );
	}

	result = GetIpAddrTable( pIpAddrTable, &dwSize, 0 );
	if (  ( result == NO_ERROR )  &&  ( pIpAddrTable != NULL )  &&  ( pIpAddrTable->dwNumEntries > 0 )  )
	{
		for ( index = 0;  index < pIpAddrTable->dwNumEntries;  index++ )
		{
			TRACE( _T("Address: %S\n"),
					inet_ntoa( *(struct in_addr *)&(pIpAddrTable->table[ index ].dwAddr) ) );
			TRACE( _T("Mask:    %S\n"),
					inet_ntoa( *(struct in_addr *)&pIpAddrTable->table[ index ].dwMask) );
			TRACE( _T("Index:   %u\n"), 
					pIpAddrTable->table[ index ].dwIndex );
			TRACE( _T("BCastAddr:   %S\n"), 
					inet_ntoa( *(struct in_addr *)&pIpAddrTable->table[ index ].dwBCastAddr) );
			TRACE( _T("ReasmSize:   %u\n"), 
					pIpAddrTable->table[ index ].dwReasmSize );
			TRACE( _T("wType:   0x%04X\n"), 
					pIpAddrTable->table[ index ].wType );
			TRACE( _T("\n") );

			count ++;
		}
	}
	 else 
	{
		TRACE( _T("GetIpAddrTable failed.\n") );

		LPVOID lpMsgBuf = NULL;

		if ( FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER |
							FORMAT_MESSAGE_FROM_SYSTEM | 
							FORMAT_MESSAGE_IGNORE_INSERTS,
							NULL,
							result,
							MAKELANGID( LANG_NEUTRAL, SUBLANG_DEFAULT ),  //Default language
							(LPTSTR) &lpMsgBuf,
							0,
							NULL )
			)
		{
			TRACE( _T(" GetIpAddrTable Error:  %s\n"), lpMsgBuf );
		}

		if ( lpMsgBuf != NULL )
		{
			LocalFree( lpMsgBuf );
		}
	}

	*ppIpAddrTable = pIpAddrTable;

	return  count;
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//
// gp ^CAEgtRlNg(񓯊RlNg)@
//
int SocketConnectTimeout( 
		SOCKET & socket, // RlNVs\Pbg
		struct sockaddr *  name,   //sockaddr f[^
		int namelen,     //	sockaddr f[^̃TCYioCgj
		LONG timeout     //^CAEgԁibj
	)
{
	timeval  timev;
	timev.tv_sec = timeout;
	timev.tv_usec = 0;

  // ڑOɂ񓯊ɕύX
	unsigned long  mode = SOCK_ARG_NON_BLOCKING /*1*/;

	int result= ioctlsocket( socket, FIONBIO, &mode );
	if ( NO_ERROR != result )
	{
		return -1;
	}


  //ڑ
	result= connect( socket, name, namelen );
	if ( SOCKET_ERROR == result)
	{
		int errono = WSAGetLastError();

		if ( WSAEWOULDBLOCK == errono )
		{
		//񓯊ڑƂɓBselect()Ŋ҂B
			errno = 0;
		}
		else
		{
		//ڑs
		//^ɖ߂B
			mode = SOCK_ARG_BLOCKING;
			ioctlsocket( socket, FIONBIO, &mode );
			return -1;
		}
	}

  //i^ɖ߂j
	mode = SOCK_ARG_BLOCKING;
	result= ioctlsocket( socket, FIONBIO, &mode );
	if ( 0 < result )
	{
	  //error
		return  -1;
	}

  //ZNgő҂
	fd_set  readFd, writeFd, errFd;

	FD_ZERO( &readFd );
	FD_ZERO( &writeFd );
	FD_ZERO( &errFd );
	FD_SET( socket, &readFd );
	FD_SET( socket, &writeFd );
	FD_SET( socket, &errFd );

	int sockNum = select( 0, &readFd, &writeFd, &errFd, &timev );
	if ( 0 == sockNum )
	{
	  //timeout
		return  -1;
	}
	else 
	 if ( SOCKET_ERROR == sockNum )
	{
		return -1;
	}
	else
	 if ( FD_ISSET( socket, &readFd ) || FD_ISSET( socket, &writeFd ) )
	{
	  //ǂݏł
	}
	else
	{
	  //error
		return -1;
	}

	return 0;
}

//--------------------------------------------------------
//e
// \Pbg̏I
//
// SOCKET socket: I\Pbg
//߂l
// Ȃ
//--------------------------------------------------------
void  EndSocket( SOCKET socket )
{
	if ( socket != INVALID_SOCKET )
	{
		shutdown( socket, SD_BOTH );
		closesocket( socket );
	}
	
	//WSACleanup();  //iMFC AvP[V̏Iɍs܂j
}
////////////////////////////////////////////////////////////////////////////////////////////////////
